package de.cscherr.mcpht.config;

import de.cscherr.mcpht.MCPHTClient;
import joptsimple.util.RegexMatcher;
import me.shedaniel.autoconfig.ConfigData;
import me.shedaniel.autoconfig.annotation.Config;
import me.shedaniel.autoconfig.annotation.ConfigEntry;
import java.util.regex.Pattern;
import java.util.regex.Matcher;

@Config(name = "mcphtconf")
public class MCPHTConfig implements ConfigData {
    @ConfigEntry.Category("Networking")
    @ConfigEntry.Gui.CollapsibleObject
    public NetworkLoggingScheme networkLogging = new NetworkLoggingScheme();

    public void onSave() {
        MCPHTClient.LOGGER.info("saving and processing configs");
        compileFilter();
    }

    public void onLoad() {
        MCPHTClient.LOGGER.info("loading configs");
        compileFilter();
    }

    private void compileFilter() {
       this.networkLogging.filter = Pattern.compile(this.networkLogging.regex);
    }

    public static class NetworkLoggingScheme {
        public boolean RX = false;
        public boolean TX = false;
        public NetworkPacketVerbosity verbosity = NetworkPacketVerbosity.NAME;
        public String regex = "";
        public enum NetworkPacketVerbosity {
            ALL,
            NAME
        }
        @ConfigEntry.Gui.Excluded
        public Pattern filter;
    }
}
